<template>
  <v-container class="app-cities" fluid>
    <h3 class="display-1 text-center font-weight-bold mb-5 mt-1 accent--text">
      Explore Apartments in Major Cities in Texas
    </h3>
    <v-row>
      <v-col v-for="city in cities" :key="city.name" md="6" cols="12">
        <v-card flat tile @click="() => goToSearch(city)">
          <v-img
            :src="city.src"
            :aspect-ratio="1.618"
            class="white--text align-center background-cover"
          >
            <v-card-subtitle class="text-center title pa-0 white--text">
              Search Apartments in
            </v-card-subtitle>
            <v-card-title class="display-2 pt-0 justify-center text-uppercase font-weight-medium" v-text="city.fullName.replace(', TX', '')" />
            <template v-slot:placeholder>
              <v-skeleton-loader
                class="flex-grow-1"
                type="image"
                style="height: 100%"
              />
            </template>
          </v-img>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api'
import { useQuery } from '../hooks'

interface City {
  src: string
  name: string
  type: string[]
  fullName: string
  viewport: [number, number][]
}

export default defineComponent({
  setup (_, context) {
    const data = context.root.$store.getters.getConfiguration('main-cities')
    const { setFilters } = useQuery(context)

    const goToSearch = (city: City) => {
      setFilters([
        { key: 'search', value: city.fullName },
        { key: 'locationComp', value: ['texas', city.name.toLowerCase()] }
      ])
    }

    return {
      cities: data.cities,
      goToSearch
    }
  }
})
</script>

<style>
.app-cities .v-responsive.v-image .v-image__image.v-image__image--cover {
  transition: all 200ms ease;
}
.app-cities .v-responsive.v-image:hover .v-image__image.v-image__image--cover {
  transform: scale(1.1);
}
</style>
